> For the complete documentation index, see [llms.txt](https://docs.notcentralised.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.notcentralised.com/circuits/hashreceiver.md).

# HashReceiver

The `HashReceiver` circuit is intended for handling and validating the transfer of amounts to a receiver. It creates hashed versions of the amount transferred and the balance of the receiver before and after the transfer.

### Input Signals

The circuit takes the following inputs:

1. **amount**: The amount to be transferred to the receiver.
2. **receiverBalanceBeforeTransfer**: The receiver's balance before the transfer occurs.

```circom
signal input amount;  
signal input receiverBalanceBeforeTransfer;
```

### Output Signals

The circuit outputs the following signals:

1. **receiverBalanceBeforeTransferHash**: The hash of the receiver's balance before the transfer occurs.
2. **receiverBalanceAfterTransferHash**: The hash of the receiver's balance after the transfer has occurred.
3. **amountHash**: The hash of the amount that is transferred.

```circom
signal output receiverBalanceBeforeTransferHash;
signal output receiverBalanceAfterTransferHash;
signal output amountHash;
```

### Components

The circuit utilizes the following components:

* **comp1**: A comparator to ensure that the `amount` is greater than or equal to zero.

```circom
component comp1 = GreaterEqThan(252);
comp1.in[0] <== amount;
comp1.in[1] <== 0;
comp1.out === 1;
```

* **hashAmount**: A `Poseidon` hashing function to create a hash of the `amount`.

```circom
component hashAmount = Poseidon(1);
hashAmount.inputs[0] <== amount;
amountHash <== hashAmount.out;
```

* **hashBeforeBalance**: A `Poseidon` hashing function to create a hash of the receiver's balance before the transfer.

```circom
component hashBeforeBalance = Poseidon(1);
hashBeforeBalance.inputs[0] <== receiverBalanceBeforeTransfer;
receiverBalanceBeforeTransferHash <== hashBeforeBalance.out;
```

* **hashAfterBalance**: A `Poseidon` hashing function to create a hash of the receiver's balance after the transfer.

```circom
component hashAfterBalance = Poseidon(1);
hashAfterBalance.inputs[0] <== receiverBalanceBeforeTransfer + amount;
receiverBalanceAfterTransferHash <== hashAfterBalance.out;
```

### External Circuit Inclusions

The circuit includes `poseidon` and `comparators` circuits from the `circomlib` library.

```circom
include "../../node_modules/circomlib/circuits/poseidon.circom";
include "../../node_modules/circomlib/circuits/comparators.circom";
```

### Main Component

The main component of this circuit file is the `HashReceiver` template.

```circom
component main = HashReceiver();
```

The `HashReceiver` circuit is used primarily for creating hashed versions of the amount being transferred and the receiver's balance before and after the transfer. This can be used for transaction verification and integrity checks within your application.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.notcentralised.com/circuits/hashreceiver.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
